=== debian/changelog ===
ndiswrapper (1.56-1) unstable; urgency=low

  * Imported Upstream version 1.56
  * Drop all patches, they are shipped upstream now.
  * debian/ndiswrapper.8, debian/loadnsisdriver.8: Escape the "-".

 -- Julian Andres Klode <jak@debian.org>  Sun, 14 Feb 2010 14:28:28 +0100

ndiswrapper (1.55-2) unstable; urgency=low

  * use-conf-in-modprobe-d.diff: Use /etc/modprobe.d/ndiswrapper.conf,
    not /etc/modprobe.d/ndiswrapper.
  * fix-cmpxchg8b.diff: Fix compilation for kernel >= 2.6.31 on i386
    (Closes: #568065).

 -- Julian Andres Klode <jak@debian.org>  Tue, 02 Feb 2010 08:21:45 +0100

ndiswrapper (1.55-1) unstable; urgency=low

  * Imported Upstream version 1.55
  * fix-typo-in-netdev-ops-struct.patch: Drop patch, now upstream.
  * debian/control: Increase Standards-Version to 3.8.4.
  * Create a ndiswrapper-dkms package, recommend it in ndiswrapper-
    utils-1.9.
  * debian/control: Add Vcs-Git and Vcs-Browser fields.
  * debian/control: Add ${misc:Depends} to ndiswrapper-source
    dependencies.
  * Switch to 3.0 (quilt) source package format.

 -- Julian Andres Klode <jak@debian.org>  Mon, 01 Feb 2010 18:35:25 +0100

ndiswrapper (1.54-2) unstable; urgency=low

  * Fix FTBFS with kernel 2.6.29 (Closes: #521212)
    - Patch by Stefan Lippers-Hollmann <s.L-H@gmx.de>
  * debian/control: Change section of ndiswrapper-source to "kernel".

 -- Julian Andres Klode <jak@debian.org>  Sat, 28 Mar 2009 17:55:43 +0100

ndiswrapper (1.54-1) unstable; urgency=low

  * New upstream release
    - Fixes building with Kernel 2.6.27 and newer (Closes: #519988)
  * Dropping all our patches, all included upstream
  * Upgrade to Policy 3.8.1, no changes required

 -- Julian Andres Klode <jak@debian.org>  Tue, 17 Mar 2009 18:35:09 +0100

ndiswrapper (1.53-2) unstable; urgency=high

  * Add debian/patches/CVE-2008-4395.patch to fix a vulnerability in handling
    of long ESSIDs which allows execution of code as root via remote attacker.
    (Closes: #504696)

 -- Kel Modderman <kel@otaku42.de>  Thu, 06 Nov 2008 21:06:38 +1000

ndiswrapper (1.53-1) unstable; urgency=low

  [ Kel Modderman ]
  * New upstream release. (Closes: #484019)
  * Include driver/*.sh in debianized ndiswrapper module tarball.
  * The distclean Makefile target no longer exists, use clean instead.
  * No longer need to define KSRC in debian/rules/modules, upstream Makefile
    requires only the KBUILD variable.
  * Major behaviour change in ndiswrapper-common wrappers for loadndisdriver
    and ndiswrapper utils:
    - check required utils_version attribute of currently installed
      ndiswrapper kernel module, use this version instead of latest version if
      called interactively
    - fallback to detection of latest API version when the information cannot
      be determined from the kernel module (not yet installed)
  * Remove dilinger from Uploaders as per his request.
  * Remove commented out quilt related code from debian/rules.

  [ Julian Andres Klode ]
  * debian/control{,.modules.in}:
    - Make me the new maintainer and move Kel to uploaders
    - Add Dm-Upload-Allowed
    - Remove VCS-* fields first, until the new repository has been created
    - Add information to description that pre-compiled modules may be available
    - Update the Standards Version to 3.8.0
  * debian/copyright: Follow machine-interpretable copyright
  * debian/patches/modules-build.diff: build correctly if only the modules
    target is built or in parallel (LP: #241547) (backported from SVN, r2670)
  * Build-Depend on quilt and add README.source

 -- Julian Andres Klode <jak@jak-linux.org>  Mon, 14 Jul 2008 21:56:42 +0200

ndiswrapper (1.52-1) unstable; urgency=low

  * New upstream release.
  * Rewrite debian/rules as a debhelper-cetric Makefile, rather than a cdbs
    dependent Makefile fragment. [debian/control, debian/rules]
  * Drop spurious dependencies of 'gcc' for ndiswrapper-source,
    '${perl:Depends}' for ndiswrapper-utils-1.9 and '${shlibs:Depends},
    ${perl:Depends}' for ndiswrapper-common. They were never used.

 -- Kel Modderman <kel@otaku42.de>  Thu, 07 Feb 2008 23:15:29 +1000

ndiswrapper (1.51-1) unstable; urgency=low

  * New upstream release
  * update standards version to 3.7.3, no changes necessary.

 -- Kel Modderman <kel@otaku42.de>  Sun, 23 Dec 2007 00:20:49 +1000

ndiswrapper (1.50-1) unstable; urgency=low

  * New upstream release.
  * Fix tarball name in README.Debian,
    s/ndiswrapper-source.tar.bz2/ndiswrapper.tar.bz2/.
  * Use relative dirname in debian/ndiswrapper-source.dirs

 -- Kel Modderman <kel@otaku42.de>  Fri, 30 Nov 2007 22:15:20 +1000

ndiswrapper (1.49-1) unstable; urgency=low

  * New upstream release.

 -- Kel Modderman <kel@otaku42.de>  Tue, 30 Oct 2007 20:29:05 +1000

ndiswrapper (1.49~rc4-1) unstable; urgency=low

  * New upstream release candidate.
  * Support for Linux 2.6.23. (Closes: #446359)
  * Use Homepage: field of debian control instead of pseudo standard with
    double spacing and paragraph break for each binary package.
  * Drop debian/patches/kbuild-only.patch, applied upstream.
  * Fix DIST_DESTDIR target in debian/rules.modules to prevent installation of
    module to "odd" path. (Closes: #395081)
  * Add Vcs debian/control tokens to reflect current maintenance archive.
  * Extended description no longer states that full kernel source is required
    to compile this module. It also capitalizes "linux". (Closes: #420688)
  * Recommend wireless-tools. (Closes: #444613)
  * Install debianized ndiswrapper tarball to /usr/src/ndiswrapper.tar.bz2 and
    not /usr/src/ndiswrapper-source.tar.bz2; this is a pseudo-guideline for
    module packages now.

 -- Kel Modderman <kel@otaku42.de>  Tue, 16 Oct 2007 16:12:01 +1000

ndiswrapper (1.47-2) unstable; urgency=low

  * Define KBUILD, KSRC and KVERS everytime we use upstream Makefile on module
    build to avoid failure due to increased sanity checking.

 -- Kel Modderman <kel@otaku42.de>  Mon, 02 Jul 2007 21:44:36 +1000


