=== debian/control ===
Source: ndiswrapper
Section: misc
Priority: optional
Maintainer: Julian Andres Klode <jak@debian.org>
Uploaders: Kel Modderman <kel@otaku42.de>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 5), bzip2, dkms
Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
Homepage: http://ndiswrapper.sourceforge.net/

Package: ndiswrapper-common
Architecture: all
Depends: ${misc:Depends}
Replaces: ndiswrapper-utils
Suggests: ndiswrapper-source
Description: Common scripts required to use the utilities for ndiswrapper
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package contains wrapper scripts to call out to the proper
 versions of whatever -utils-X.X package is installed.

Package: ndiswrapper-utils-1.9
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, ndiswrapper-common
Recommends: ndiswrapper-dkms
Suggests: ndiswrapper-source
Description: Userspace utilities for the ndiswrapper Linux kernel module
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package contains the userspace tools. You will also need the kernel
 module package.

Package: ndiswrapper-source
Architecture: all
Section: kernel
Depends: ${misc:Depends}, module-assistant, debhelper (>= 5), bzip2
Suggests: kernel-package
Description: Source for the ndiswrapper Linux kernel module
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package provides the source code for the ndiswrapper kernel module.

Package: ndiswrapper-dkms
Architecture: all
Section: kernel
Depends: ${misc:Depends}
Description: Source for the ndiswrapper Linux kernel module (DKMS)
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package provides the source code for ndiswrapper kernel module to be
 build with dkms.
