=== debian/changelog ===
ndiswrapper (1.56+r2729-1) unstable; urgency=low

  * Imported Upstream version 1.56+r2729
    - Support for Kernels 2.6.36 - 2.6.38 (LP: #660664, Closes: #604880)
  * Drop patch for Linux 2.6.35, included in snapshot

 -- Julian Andres Klode <jak@debian.org>  Mon, 14 Mar 2011 15:21:40 +0100

ndiswrapper (1.56-3) unstable; urgency=low

  * Use a reworked and working Linux 2.6.35 support patch (LP: #613796)

 -- Julian Andres Klode <jak@debian.org>  Mon, 13 Sep 2010 19:59:08 +0200

ndiswrapper (1.56-2) unstable; urgency=low

  * Only suggest ndiswrapper-dkms on Ubuntu
  * Add support for Linux 2.6.35 (LP: #590090)
  * Set Standards-Version to 3.9.1

 -- Julian Andres Klode <jak@debian.org>  Tue, 03 Aug 2010 14:21:33 +0200
