=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
@@ -28,8 +28,8 @@
 Package: ndiswrapper-utils-1.9
 Architecture: i386 amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ndiswrapper-common
-Recommends: ndiswrapper-dkms
-Suggests: ndiswrapper-source
+Recommends: ${distro:Recommends}
+Suggests: ${distro:Suggests}, ndiswrapper-source
 Description: Userspace utilities for the ndiswrapper Linux kernel module
  Some vendors do not release specifications of the hardware or provide a
  Linux driver for their wireless network cards. This project implements
