=== debian/rules ===
#!/usr/bin/make -f
version := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
recommends := $(shell dpkg-vendor --derives-from Ubuntu || echo "ndiswrapper-dkms")
suggests := $(shell dpkg-vendor --derives-from Ubuntu && echo "ndiswrapper-dkms" || true)
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-indep build-arch

build-indep: build-indep-stamp
build-indep-stamp:
	touch $@

build-arch: build-arch-stamp
build-arch-stamp:
	dh_testdir

	$(MAKE) -C utils

	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) -C utils distclean

	dh_clean build-arch-stamp build-indep-stamp debian/ndiswrapper-dkms.dkms

debian/ndiswrapper-dkms.dkms: debian/ndiswrapper-dkms.dkms.in
	sed s/@VERSION@/$(version)/g $< > $@

install: install-indep install-arch

install-indep: build-indep debian/ndiswrapper-dkms.dkms
	dh_testdir
	dh_testroot
	dh_clean -k -i
	dh_installdirs -i
	dh_install -i

	install -D -m 0755 debian/rules.modules \
		debian/tmp/modules/ndiswrapper/debian/rules

	for f in *.modules.in control compat copyright changelog; do \
		install -m 0644 debian/$$f \
			debian/tmp/modules/ndiswrapper/debian/; \
	done

	install driver/Makefile driver/*.[chS] driver/*.sh \
		debian/tmp/modules/ndiswrapper/

	mkdir -p debian/ndiswrapper-source/usr/src/
	tar jcf debian/ndiswrapper-source/usr/src/ndiswrapper.tar.bz2 \
		-C debian/tmp modules

	# Create the ndiswrapper-dkms package.
	dh_install -pndiswrapper-dkms driver/Makefile usr/src/ndiswrapper-$(version)
	dh_install -pndiswrapper-dkms driver/*.[chS]  usr/src/ndiswrapper-$(version)
	dh_install -pndiswrapper-dkms driver/*.sh     usr/src/ndiswrapper-$(version)
	dh_dkms -pndiswrapper-dkms

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k -s

	install -D -m755 utils/loadndisdriver \
		debian/ndiswrapper-utils-1.9/sbin/loadndisdriver-1.9
	install -D -m755 utils/ndiswrapper \
		debian/ndiswrapper-utils-1.9/usr/sbin/ndiswrapper-1.9
	install -D -m644 loadndisdriver.8 \
		debian/ndiswrapper-utils-1.9/usr/share/man/man8/loadndisdriver-1.9.8
	install -D -m644 ndiswrapper.8 \
		debian/ndiswrapper-utils-1.9/usr/share/man/man8/ndiswrapper-1.9.8

binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installman -i
	dh_installdocs -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i -- -Vdistro:Recommends=$(recommends) \
	                    -Vdistro:Suggests=$(suggests)
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build-arch install-arch
	dh_testdir -s
	dh_testroot -s
	dh_installman -s
	dh_installdocs -s
	dh_installchangelogs -s ChangeLog
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s -- -Vdistro:Recommends=$(recommends) \
	                    -Vdistro:Suggests=$(suggests)
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean install install-indep install-arch binary-indep binary-arch binary
