=== driver/Makefile ===
--- 
+++ 
@@ -6,8 +6,8 @@
 	loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
 	ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c pe_linker.c \
 	pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h win2lin_stubs.S \
-	winnt_types.h workqueue.c wrapmem.h wrapmem.c wrapper.c wrapper.h \
-	wrapndis.c wrapndis.h
+	winnt_types.h workqueue.c wrapmem.c wrapmem.h wrapndis.c wrapndis.h \
+	wrapper.c wrapper.h
 
 # By default, we try to compile the modules for the currently running
 # kernel.  But it's the first approximation, as we will re-read the
@@ -42,13 +42,7 @@
 $(error Cannot find UTS_RELEASE in $(VERSION_H), has 'make modules_prepare' been called?)
 endif
 
-ifdef DIST_DESTDIR
-DESTDIR = $(DIST_DESTDIR)
-else
-DESTDIR ?= /
-endif
-
-INST_DIR ?= $(shell echo $(DESTDIR)/lib/modules/$(KVERS)/misc | sed 's^//^/^g')
+INST_DIR = /lib/modules/$(KVERS)/misc
 
 SRC_DIR=$(shell pwd)
 
@@ -66,53 +60,47 @@
 EXTRA_CFLAGS += -DDEBUG=$(DEBUG) -g
 endif
 
-# to debug timers, add option "TIMER_DEBUG=1 DEBUG=<n>"
+# to debug timers, add option "TIMER_DEBUG=1"
 ifdef TIMER_DEBUG
 EXTRA_CFLAGS += -DTIMER_DEBUG
 endif
 
-# to debug event layer, add option "EVENT_DEBUG=1 DEBUG=<n>"
+# to debug event layer, add option "EVENT_DEBUG=1"
 ifdef EVENT_DEBUG
 EXTRA_CFLAGS += -DEVENT_DEBUG
 endif
 
-# to debug USB layer, add option "USB_DEBUG=1 DEBUG=<n>"
+# to debug USB layer, add option "USB_DEBUG=1"
 ifdef USB_DEBUG
 EXTRA_CFLAGS += -DUSB_DEBUG
 endif
 
-# to debug I/O layer, add option "IO_DEBUG=1 DEBUG=<n>"
+# to debug I/O layer, add option "IO_DEBUG=1"
 ifdef IO_DEBUG
 EXTRA_CFLAGS += -DIO_DEBUG
 endif
 
-# to debug worker threads
+# to debug worker threads, add option "WORK_DEBUG=1"
 ifdef WORK_DEBUG
 EXTRA_CFLAGS += -DWORK_DEBUG
 endif
 
-# to debug memory allocation issues
+# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 to 3
 ifdef ALLOC_DEBUG
 EXTRA_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
 endif
 
-# emulate (pseudo) preemption
-ifdef WRAP_PREEMPT
-EXTRA_CFLAGS += -DWRAP_PREEMPT
-endif
-
 OBJS = crt.o hal.o iw_ndis.o loader.o ndis.o ntoskernel.o ntoskernel_io.o \
 	pe_linker.o pnp.o proc.o rtl.o wrapmem.o wrapndis.o wrapper.o
 
-EXPORTS = crt_exports.h hal_exports.h ndis_exports.h ntoskernel_exports.h \
-	ntoskernel_io_exports.h rtl_exports.h
+EXPORT_SRCS = crt.c hal.c ndis.c ntoskernel.c ntoskernel_io.c rtl.c
 
 STUB_SRCS = crt.c hal.c ndis.c ntoskernel.c ntoskernel_io.c \
 	pnp.c rtl.c wrapndis.c
 
 
 # By default, USB layer is compiled in if USB support is in kernel;
-# to disable USB support in ndiswrapper even if USB support is in kenrel,
+# to disable USB support in ndiswrapper even if USB support is in kernel,
 # add option "DISABLE_USB=1"
 ifndef DISABLE_USB
 ifeq ($(CONFIG_USB),y)
@@ -124,7 +112,7 @@
 endif
 
 ifdef ENABLE_USB
-EXPORTS += usb_exports.h
+EXPORT_SRCS += usb.c
 STUB_SRCS += usb.c
 OBJS += usb.o
 EXTRA_CFLAGS += -DENABLE_USB
@@ -142,11 +130,11 @@
 quiet_cmd_mkexport = MKEXPORT $@
 cmd_mkexport = $(SHELL) $(obj)/mkexport.sh $< $@
 
-extra-y += $(EXPORTS)
+extra-y += $(EXPORT_SRCS:.c=_exports.h)
 %_exports.h: %.c $(obj)/mkexport.sh FORCE
 	$(call if_changed,mkexport)
 
-$(addprefix $(obj)/,$(EXPORTS:_exports.h=.o)): %.o: %_exports.h
+$(addprefix $(obj)/,$(EXPORT_SRCS:.c=.o)): %.o: %_exports.h
 
 ifeq ($(CONFIG_X86_64),y)
 quiet_cmd_mkstubs = MKSTUBS $@
@@ -195,22 +183,30 @@
 modules:
 	$(MAKE) -C $(KBUILD) M=$(SRC_DIR)
 
+$(MODULE):
+	$(MAKE) modules
+
 clean:
 	rm -f *.o *.ko .*.cmd *.mod.c *.symvers modules.order *~ .\#*
 	rm -f *_exports.h win2lin_stubs.h
 	rm -rf .tmp_versions
 
-install: config_check modules
-	echo $(INST_DIR)
-	mkdir -p $(INST_DIR)
-	install -m 0644 $(MODULE) $(INST_DIR)
-ifndef DIST_DESTDIR
-	-/sbin/depmod -a $(KVERS) -b $(DESTDIR)
+install: config_check $(MODULE)
+	mkdir -p -m 0755 $(DESTDIR)$(INST_DIR)
+	install -m 0644 $(MODULE) $(DESTDIR)$(INST_DIR)
+ifndef DESTDIR
+	-/sbin/depmod -a $(KVERS)
+endif
+
+uninstall:
+	rm -f $(DESTDIR)$(INST_DIR)/$(MODULE)
+ifndef DESTDIR
+	-/sbin/depmod -a $(KVERS)
 endif
 
 dist:
 	@for file in $(DISTFILES); do \
-		cp $$file $(distdir)/$$file; \
+		cp $$file $(distdir)/$$file || exit 1; \
 	done
 
 .PHONY: all modules clean install config_check dist
