=== debian/changelog ===
ndiswrapper (1.57~rc1-1) unstable; urgency=low

  * Imported Upstream version 1.57~rc1
    - Fixes build with newer kernel version (Closes: #650012)
  * Set Standards-Version to 3.9.2

 -- Julian Andres Klode <jak@debian.org>  Fri, 25 Nov 2011 16:45:32 +0100
