=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
