## ndiswrapper 1.57

=== driver/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 MODNAME = ndiswrapper
 
 DISTFILES = \
-	Makefile crt.c divdi3.c hal.c iw_ndis.c iw_ndis.h lin2win.h loader.c \
-	loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
+	Makefile crt.c divdi3.c hal.c iw_ndis.c iw_ndis.h lin2win.S lin2win.h \
+	loader.c loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
 	ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c pe_linker.c \
 	pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h win2lin_stubs.S \
 	winnt_types.h workqueue.c wrapmem.c wrapmem.h wrapndis.c wrapndis.h \
@@ -85,7 +85,7 @@
 EXTRA_CFLAGS += -DWORK_DEBUG
 endif
 
-# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 to 3
+# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 or 2
 ifdef ALLOC_DEBUG
 EXTRA_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
 endif
@@ -145,7 +145,7 @@
 	$(call if_changed,mkstubs)
 
 $(obj)/win2lin_stubs.o: $(obj)/win2lin_stubs.h
-OBJS += win2lin_stubs.o
+OBJS += win2lin_stubs.o lin2win.o
 else
 OBJS += divdi3.o
 endif
@@ -192,7 +192,9 @@
 	rm -rf .tmp_versions
 
 install: config_check $(MODULE)
-	mkdir -p -m 0755 $(DESTDIR)$(INST_DIR)
+	@/sbin/modinfo $(MODULE) | grep -q "^vermagic: *$(KVERS) " || \
+		{ echo "$(MODULE)" is not for Linux $(KVERS); exit 1; }
+	mkdir -p -m 755 $(DESTDIR)$(INST_DIR)
 	install -m 0644 $(MODULE) $(DESTDIR)$(INST_DIR)
 ifndef DESTDIR
 	-/sbin/depmod -a $(KVERS)
