=== debian/changelog ===
ndiswrapper (1.57-1ubuntu1) precise; urgency=low

  * patch from  Joerg Schirottke <master@kanotix.com> to fix (LP: #978920)
   - patches/kernel-3-userspace-support.patch: Allow kernel 3.0+
   - Fix debian/ndiswrapper-dkms.dkms.in

 -- Oliver Grawert <ogra@ubuntu.com>  Thu, 12 Apr 2012 16:16:51 +0200

ndiswrapper (1.57-1) unstable; urgency=low

  * Imported Upstream version 1.57
    - Fixes build with kernel 3.2 (Closes: #655223, LP: #910597)
  * Enable hardening build flags (Closes: #655249)
  * patches/ndiswrapper-harden.patch: Use $(shell X) instead of `X`
  * Update to Policy 3.9.3, copyright-format 1.0

 -- Julian Andres Klode <jak@debian.org>  Mon, 05 Mar 2012 16:49:02 +0100
