## ndiswrapper 1.58~rc1

=== debian/changelog ===
ndiswrapper (1.58~rc1-0ubuntu1) raring; urgency=low

  * New upstream release. (LP: #1023645)
   - add a patch to fix for 3.6+ kernels, maybe.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Thu, 20 Dec 2012 22:44:06 +0000
