## ndiswrapper 1.58

=== debian/changelog ===
ndiswrapper (1.58-2) unstable; urgency=low

  * Add Support for Kernel 3.10; patch by Canonical (Closes: #717152)
  * Update Ubuntu patch to re-add support for older kernels

 -- Julian Andres Klode <jak@debian.org>  Sun, 04 Aug 2013 13:41:30 +0200

ndiswrapper (1.58-1) unstable; urgency=low

  * Imported Upstream version 1.58 (Closes: #707665)
  * Use $KERNELRELEASE as target kernel version (Closes: #693638)
  * Add BUILT_MODULE_NAME to dkms config file (Workaround for: #690747)
  * Add support for kernel 3.9
  * Patch userland for 3.X kernels
  * Set Standards-Version to 3.9.4

 -- Julian Andres Klode <jak@debian.org>  Sun, 14 Jul 2013 20:02:35 +0200
